<?php
namespace Drcsystems\DrcSlickCarousel\Tests\Unit\Controller;
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2016 
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Test case for class Drcsystems\DrcSlickCarousel\Controller\SlidesController.
 *
 */
class SlidesControllerTest extends \TYPO3\CMS\Core\Tests\UnitTestCase
{

	/**
	 * @var \Drcsystems\DrcSlickCarousel\Controller\SlidesController
	 */
	protected $subject = NULL;

	public function setUp()
	{
		$this->subject = $this->getMock('Drcsystems\\DrcSlickCarousel\\Controller\\SlidesController', array('redirect', 'forward', 'addFlashMessage'), array(), '', FALSE);
	}

	public function tearDown()
	{
		unset($this->subject);
	}

	/**
	 * @test
	 */
	public function listActionFetchesAllSlidessFromRepositoryAndAssignsThemToView()
	{

		$allSlidess = $this->getMock('TYPO3\\CMS\\Extbase\\Persistence\\ObjectStorage', array(), array(), '', FALSE);

		$slidesRepository = $this->getMock('Drcsystems\\DrcSlickCarousel\\Domain\\Repository\\SlidesRepository', array('findAll'), array(), '', FALSE);
		$slidesRepository->expects($this->once())->method('findAll')->will($this->returnValue($allSlidess));
		$this->inject($this->subject, 'slidesRepository', $slidesRepository);

		$view = $this->getMock('TYPO3\\CMS\\Extbase\\Mvc\\View\\ViewInterface');
		$view->expects($this->once())->method('assign')->with('slidess', $allSlidess);
		$this->inject($this->subject, 'view', $view);

		$this->subject->listAction();
	}

	/**
	 * @test
	 */
	public function showActionAssignsTheGivenSlidesToView()
	{
		$slides = new \Drcsystems\DrcSlickCarousel\Domain\Model\Slides();

		$view = $this->getMock('TYPO3\\CMS\\Extbase\\Mvc\\View\\ViewInterface');
		$this->inject($this->subject, 'view', $view);
		$view->expects($this->once())->method('assign')->with('slides', $slides);

		$this->subject->showAction($slides);
	}
}
